poj3126
题目链接:
题目:
Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 10737 | Accepted: 6110 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on
their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0这道题目思想非常easy 。。可是实现起来比較复杂 。。
。
用bfs搜索。。
。
还有就是假设预处理打素数表的话会快许多。。
。
。可是我打的素数表很很的戳。。
。
。。可是还是0MS.。。
代码例如以下:
#include<cstdio> #include<queue> #include<iostream> #include<cstring> #include<cmath> using namespace std; const int maxn=9999+10; int prime[maxn]; bool vis[maxn]; struct point { int x; int time; }; point start,end; bool is_prime(int x) { for(int i=2;i<=sqrt(x*1.0);i++) { if(x%i==0) return false; } return true; } void init() { for(int i=1000;i<=maxn;i++) prime[i]=i; for(int i=1000;i<=maxn;i++) { if(is_prime(prime[i])) prime[i]=1; else prime[i]=0; } } int bfs() { queue<point>q; point old,current; q.push(start); while(!q.empty()) { old=q.front(); q.pop(); if(old.x==end.x) return old.time; for(int i=1;i<=9;i=i+2)//个位 { current.x=old.x/10*10+i; if(current.x==old.x) continue; // printf("%d\n",current.time); if(prime[current.x]&&!vis[current.x]) { vis[current.x]=1; current.time=old.time+1; q.push(current); } } for(int i=0;i<=9;i++) { current.x=old.x/100*100+i*10+old.x%10; if(current.x==old.x) continue; // printf("%d\n",current.time); if(prime[current.x]&&!vis[current.x]) { vis[current.x]=1; current.time=old.time+1; q.push(current); } } for(int i=0;i<=9;i++) { int tmp1=old.x%100; current.x=(old.x/1000*10+i)*100+tmp1; if(current.x==old.x) continue; if(prime[current.x]&&!vis[current.x]) { vis[current.x]=1; current.time=old.time+1; q.push(current); } } for(int i=1;i<=9;i++) { int tmp1=old.x%1000; current.x=i*1000+tmp1; if(current.x==old.x) continue; if(prime[current.x]&&!vis[current.x]) { vis[current.x]=1; current.time=old.time+1;//printf("%d\n",current.time); q.push(current); } } } return -1; } int main() { memset(prime,0,sizeof(prime)); int T; scanf("%d",&T); init(); while(T--) { memset(vis,false,sizeof(vis)); scanf("%d %d",&start.x,&end.x); start.time=0; int ans=bfs(); //printf("nas:%d\n",ans); if(ans!=-1) printf("%d\n",ans); else printf("Impossible\n"); } return 0; }